// JavaScript Document
displayname="TimeZone";
versionstring="1.3.0";
releasedatestring="28 January 2010";
author="scribbly";
updateurl="http://scribbly.mitupela.net/programmes/farr/timezone/timezone.zip";
homepageurl="http://scribbly.mitupela.net/programmes/farr/timezone/";
shortdescription="TimeZone";
longdescription="This plugin displays the current time in different TimeZones as you type.";
advconfigstring="TimeZone";
readmestring="readme.html";
iconfilename="timezone.ico";

aliasstr="tz";
regexstr="^(tz)\\s+(.*)";
scriptregex=/^(tz)\s{0,1}(.*)/;
//scriptregex=/^tz\s+((@from\s\w*)|(@at\s.*( Pm| pm| PM| am| Am| AM))|(@to\s\w*\s))\s?((@from\s\w*)|(@at\s.*( Pm| pm| PM| am| Am| AM))|(@to\s\w*\s))?\s?((@from\s\w*)|(@at\s.*( Pm| pm| PM| am| Am| AM))|(@to\s\w*\s))?/;
regexfilterstr="";
keywordstr="";
scorestr="300";

TaD_full="http://www.timeanddate.com/worldclock/full.html"
TaD_url="http://www.timeanddate.com/worldclock/city.html?n="
var tzMonths=new Array(31,28,31,30,31,30,31,31,30,31,30,31);
var tzTaD=new Array('http://www.timeanddate.com/worldclock/full.html','http://www.timeanddate.com/worldclock/full.html?sort=1')
var tzFavs=new Array();
//var listFavourites = new Array()
var defMonths = "January,February,March,April,May,June,July,August,September,October,November,December"
var defMonthAbrev="Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec";
var defDays="Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday";
var defDayAbrev="Sun,Mon,Tue,Wed,Thu,Fri,Sat";

// type
UNKNOWN=0; FILE=1; FOLDER=2; ALIAS=3; URL=4; PLUGIN=5; DUMMYBIG=79000;
// Postprocessing
IMMEDIATE_DISPLAY=0; ADDSCORE=1; MATCH_AGAINST_SEARCH=2;
// search state
STOPPED=0; SEARCHING=1;
// trigger returns
HANDLED=1; CLOSE=2;

// Settings
var listType=2;
var preferFARR=1;
var loadEachLaunch=0;
var dateFormat="E hh:mm a";
var useLocale="English.ini";
var utcOffset=null;
var favList=new Array(0);

// Icons
var icoOptions = "Icons\\settings.ico";
var icoInfo="Icons\\information.ico";
var icoDownload="Icons\\Download.ico";
var icoFavTimeZone="Icons\\favTimeZone.ico"
var icoTimeZone="Icons\\TimeZone.ico"
// Paths
var jsCurrentDir = "";
var currentDirectory = "";

var tzSearching = 1;

function onSearchBegin(querykey, explicit, queryraw, querynokeyword) {
  if(!explicit) {
    if(aliasstr.indexOf(querynokeyword)!=-1) {
      FARR.setState(querykey,1);
      FARR.emitResult(querykey,aliasstr, aliasstr, icoTimeZone,ALIAS,IMMEDIATE_DISPLAY,300);
      FARR.setState(querykey,0);
    }
    return;
  }
	var countResults = 0;
	
  FARR.setStrValue("statusbar","TimeZone: the world in your FARR...");
  FARR.setState(querykey,SEARCHING);
	// Write favourites to result window
  for(f=0;f<favList.length;f++) {
		if(favList[f].url!=''){
      var useThisFormat = '';
      //FARR.debug(favList[f].format);
      if(favList[f].format == ''){useThisFormat=dateFormat} else {useThisFormat=favList[f].format}
			var rightNow = new Date();
	    var calcD = rightNow.add("s" , favList[f].diff );
	    var strTitle = favList[f].label + ' ' + calcD.format(useThisFormat);
	  	FARR.emitResult(querykey, strTitle, favList[f].url, icoFavTimeZone, URL, IMMEDIATE_DISPLAY, 1000);
	  	countResults+=1;
	  	if(countResults>9){
  			FARR.setStrValue("setshowallmode", "" );
			}
			}
	}
	// Write the options available
  FARR.emitResult(querykey, "TimeZone Options", "Settings", icoOptions,UNKNOWN, IMMEDIATE_DISPLAY,500);
  FARR.emitResult(querykey, "TimeZone Info", currentDirectory + "\\readme.html /stayopen", icoInfo,FILE, IMMEDIATE_DISPLAY,500);
  FARR.emitResult(querykey, "TimeZone ReDownload", "Download", icoDownload,UNKNOWN, IMMEDIATE_DISPLAY,500);
  FARR.setState(querykey,STOPPED);
	countResults+=3;
	if(countResults>9){
		FARR.setStrValue("setshowallmode", "" );
	}

}

function onRegexSearchMatch(querykey, queryraw,querynokeyword, modifier, triggermethod) {

  var match_reg = queryraw.match(scriptregex);
  var tzCommand = RegExp.$1
  var tzSearchString = RegExp.$2
  doQuery(querykey , tzSearchString);
}

function onProcessTrigger(path, caption, groupname, pluginid, thispluginid,score, entrytype, args, triggermode) {
		//FARR.debug("Path: " + path + "; Caption: " + caption + "; GroupName: " + groupname + "; PluginID: " + pluginid + "; ThisPlugin: " + thispluginid + "; Score: " + score + "; EntryType: " + entrytype + "Args: " + args + "; TriggerMode: " + triggermode);
		if(pluginid!=thispluginid){
			return false;
		}
		// FARRTimeZone.exe requires the TimezoneOffset to calculate the current time difference
		var currentDate = new Date();
		var currentUtcOffset = currentDate.getTimezoneOffset();
    if(caption=="TimeZone Options"){
		 	 FARR.exec( "FARRTimeZone.exe", "settings " + currentUtcOffset ,jsCurrentDir);
			 return 3;
		}
    if(caption=="TimeZone ReDownload"){
			 checkData(true);
			 return 1;
		}
		if(preferFARR==1){
  		FARR.setStrValue("launch", "htmlviewurl " + path);
  		return 1;
		}
		return 0;
}

function onDoAdvConfig() {
  	FARR.exec( "FARRTimeZone.exe", "settings " + currentUtcOffset ,jsCurrentDir);
    return true;
}
function onOptionsChanged() {
		//
    var xmlUTCOffset = new ActiveXObject("MSXML2.DOMDocument");
    var node, value;
    xmlUTCOffset.load(currentDirectory+"\\Data\\utcOffset.xml")

      node = xmlUTCOffset.selectSingleNode("options/offset");
      if (node) {
        utcOffset = node.text;
      }
    xmlUTCOffset=null;

  // Load Settings
  listType=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini", "TimeZone", "listType" , 1);
  preferFARR=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini", "TimeZone", "preferFARR" , 1);
  loadEachLaunch=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini", "TimeZone", "loadEachLaunch" , 0);
  dateFormat=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini" , "TimeZone", "dateFormat" , "E hh:mm a");
	useLocale=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini" , "TimeZone" , "useLocale" , "English.ini");

  for(f=0;f<11;f++)
  {
   num=f+1;
   favURLName = "Fav"+num;
	 favZONE=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini" , favURLName, "Zone" , "");
	 favURL=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini" , favURLName, "URL" , favZONE);
	 favREPLACE=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini" , favURLName, "Replace" , 0);
	 favLABEL=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini" , favURLName, "Label" , "");
	 favFORMAT=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini" , favURLName, "Format" , "");
	 favList[f]= new favourite(favURL , favZONE , favREPLACE , favLABEL , favFORMAT , 0);
	}

	//Load Date Locale
	var locMonthNames = FARR.getIniValue(jsCurrentDir + "\\Locale\\" + useLocale , "DateStrings" , "monthNames" , defMonths);
	// Using UTF8.decode was an attempt to use UTF8/ANSI characters in FARR: A total failure!!
	locMonthNames = UTF8.decode(locMonthNames);
	Date.monthNames = locMonthNames.split(",");
	var locMonthAbbreviations = FARR.getIniValue(jsCurrentDir + "\\Locale\\" + useLocale , "DateStrings" , "monthAbbreviations" , defMonthAbrev);
	locMonthAbbreviations = UTF8.decode(locMonthAbbreviations);
	Date.monthAbbreviations = locMonthAbbreviations.split(",");
	var locDayNames = FARR.getIniValue(jsCurrentDir + "\\Locale\\" + useLocale , "DateStrings" , "dayNames" , defDays);
	locDayNames = UTF8.decode(locDayNames);
  Date.dayNames = locDayNames.split(",");
	var locDayAbbreviations = FARR.getIniValue(jsCurrentDir + "\\Locale\\" + useLocale , "DateStrings" , "dayAbbreviations" , defDayAbrev);
	locDayAbbreviations = UTF8.decode(locDayAbbreviations);
	Date.dayAbbreviations = locDayAbbreviations.split(",");

	// If checkData returns false then FARRTimeZone.exe is downloading fresh data
	// When the download has completed then this function will be called and checkData will return true (UTC Offsets will be the same)
  if(checkData(false)==false) {return;}
	// If we get here we can load the data
  LoadData();
}
function doQuery(querykey , querynokeyword){
  
  var foundZones = listTimeZones.find( querynokeyword );
  var pP = IMMEDIATE_DISPLAY;

  if (foundZones.length > 0) {
    for (i = 0; i < foundZones.length; i++) {
			var rightNow = new Date();
      var calcD = rightNow.add("s" , listTimeZones[ foundZones[i] ].diff );
      var strTitle = listTimeZones[ foundZones[i] ].title + ' ' + calcD.format(dateFormat);
      FARR.emitResult(querykey, strTitle, listTimeZones[ foundZones[i] ].path, icoTimeZone, URL, IMMEDIATE_DISPLAY, scorestr);
      FARR.notifyStateChange(querykey);
    }
  }
  FARR.setState(querykey,0);
}

function onInit(c) {
  currentDirectory=c;
 	jsCurrentDir = c.replace(/\\/g,"\\\\");
  var xmlUTCOffset=new ActiveXObject("MSXML2.DOMDocument");
  // If the UTC Offset file does not exist we'll create one
  if(!xmlUTCOffset.load(currentDirectory+"\\Data\\utcOffset.xml")) {
		var d = new Date()
		// Get the current Offset
		var utcOffset = d.getTimezoneOffset()
		// Write it to the settings file
    xmlUTCOffset.loadXML("<options><offset>"+utcOffset+"</offset></options>");
    xmlUTCOffset.save(currentDirectory+"\\Data\\utcOffset.xml");
  }
  xmlUTCOffset=null;
  loadEachLaunch=FARR.getIniValue(jsCurrentDir + "\\TimeZone.ini", "TimeZone", "loadEachLaunch" , 0);
 	if (loadEachLaunch==1) {
		 checkData(true);
		 return;
	}

  onOptionsChanged();
}

function verify()
{
 if (xmlDoc.readyState != 4)
 {
  return false;
 }
}

function LoadData() {
    // remove all the elements
		listTimeZones.splice(0, listTimeZones.length)
    var data = new ActiveXObject("MSXML2.DOMDocument");
    data.async=false;

    var thisEntry, value, allEntries;
    var dataFile = jsCurrentDir+"\\Data\\data" + listType + ".xml"
		var fso = new ActiveXObject("Scripting.FileSystemObject")
    if(!fso.fileExists( dataFile )){
			 checkData(true);
			 // We can leave here as the download will signal when it's done
			 return true;
		}
    fso = null;
    
    data.load(dataFile);
    
    allEntries = data.documentElement;
    
		entryList=data.getElementsByTagName("Entry");
    for (i = 0; i < allEntries.childNodes.length; i++) {
      thisEntry = allEntries.childNodes[i];
				thisTitle = allEntries.childNodes[i].childNodes[0].text
				thisPath = allEntries.childNodes[i].childNodes[1].text
				thisDiff = allEntries.childNodes[i].childNodes[2].text
        listTimeZones[i] = new zoneTitlePath( thisTitle , TaD_url + "" + thisPath , thisDiff);
        for(f=0;f<favList.length;f++) {
					if(thisPath==favList[f].zone ){
            if(favList[f].replace==0) {favList[f].label = thisTitle + " " + favList[f].label}
            favList[f].diff = thisDiff
            favList[f].url = TaD_url + "" + favList[f].url
						//tzFavs[f] = new zoneTitlePath(thisTitle , TaD_url + "" + thisPath , thisDiff );
					} 
				}
        if(i<2){
					//FARR.debug(thisTitle + ': ' + thisPath + ' (' + thisDiff + ')');
				}
    }
    data=null;

	  xmlUTCOffset=null;

		return 0;

}

function checkData(force){

	// set force = false if not set
  force = typeof(force) != 'undefined' ? force : false;

	var currentDate = new Date();
	// Get current UTC Offset
	var currentUtcOffset = currentDate.getTimezoneOffset();
	// Check against current offset
  if (utcOffset!=currentUtcOffset || force==true){
		 FARR.exec( "FARRTimeZone.exe", "download " + currentUtcOffset ,jsCurrentDir);
		 return false;
	}
	return true;
}

function checkThis(date){
  FARR.debug('checkThis: ' + date);
	var y=date.getYear()+"";
	var M=date.getMonth()+1;
	var d=date.getDate();
	var E=date.getDay();
	FARR.debug('Day:' + E + ' Month:' + M + ' year:' + y)

}

var listTimeZones = new Array()
function zoneTitlePath(title , path , diff) {
	this.title = title;
	this.path = path;
	this.diff = diff;
}

function favourite( url , zone , replace , label , format , diff ) {
  this.url = url;
  this.zone = zone;
  this.replace = replace;
  this.label = label;
  this.format = format;
  this.diff = diff;
}

Array.prototype.find = function(searchStr) {
  var returnArray = false;
  for (i=0; i<this.length; i++) {
    if (typeof(searchStr) == 'object') {
      if (searchStr.test(this[i].title)) {
        if (!returnArray) { returnArray = [] }
        returnArray.push(i);
      }
    } else {
		  var regex = new RegExp( searchStr , "gi");
      if (this[i].title.match(regex) ) {
        if (!returnArray) { returnArray = [] }
        returnArray.push(i);
      }
      else {
        // No Match
      }
    }
  }
  return returnArray;
}
/**
 * Copyright (c)2005-2008 Matt Kruse (javascripttoolbox.com)
 *
 * Dual licensed under the MIT and GPL licenses.
 * This basically means you can use this code however you want for
 * free, but don't claim to have written it yourself!
 * Donations always accepted: http://www.JavascriptToolbox.com/donate/
 *
 * Please do not link to the .js files on javascripttoolbox.com from
 * your site. Copy the files locally to your server instead.
 *
 */
/*
Date functions

These functions are used to parse, format, and manipulate Date objects.
See documentation and examples at http://www.JavascriptToolbox.com/lib/date/

*/
Date.$VERSION = 1.02;

// Utility function to append a 0 to single-digit numbers
Date.LZ = function(x) {return(x<0||x>9?"":"0")+x};
// Full month names. Change this for local month names
//Date.monthNames = new Array('January','February','March','April','May','June','July','August','September','October','November','December');
// Month abbreviations. Change this for local month names
//Date.monthAbbreviations = new Array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
// Full day names. Change this for local month names
//Date.dayNames = new Array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
// Day abbreviations. Change this for local month names
//Date.dayAbbreviations = new Array('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
// Used for parsing ambiguous dates like 1/2/2000 - default to preferring 'American' format meaning Jan 2.
// Set to false to prefer 'European' format meaning Feb 1
Date.preferAmericanFormat = true;

// If the getFullYear() method is not defined, create it
if (!Date.prototype.getFullYear) {
  Date.prototype.getFullYear = function() { var yy=this.getYear(); return (yy<1900?yy+1900:yy); } ;
}

// Parse a string and convert it to a Date object.
// If no format is passed, try a list of common formats.
// If string cannot be parsed, return null.
// Avoids regular expressions to be more portable.
Date.parseString = function(val, format) {
  // If no format is specified, try a few common formats
  if (typeof(format)=="undefined" || format==null || format=="") {
    var generalFormats=new Array('y-M-d','MMM d, y','MMM d,y','y-MMM-d','d-MMM-y','MMM d','MMM-d','d-MMM');
    var monthFirst=new Array('M/d/y','M-d-y','M.d.y','M/d','M-d');
    var dateFirst =new Array('d/M/y','d-M-y','d.M.y','d/M','d-M');
    var checkList=new Array(generalFormats,Date.preferAmericanFormat?monthFirst:dateFirst,Date.preferAmericanFormat?dateFirst:monthFirst);
    for (var i=0; i<checkList.length; i++) {
      var l=checkList[i];
      for (var j=0; j<l.length; j++) {
        var d=Date.parseString(val,l[j]);
        if (d!=null) {
          return d;
        }
      }
    }
    return null;
  };

  this.isInteger = function(val) {
    for (var i=0; i < val.length; i++) {
      if ("1234567890".indexOf(val.charAt(i))==-1) {
        return false;
      }
    }
    return true;
  };
  this.getInt = function(str,i,minlength,maxlength) {
    for (var x=maxlength; x>=minlength; x--) {
      var token=str.substring(i,i+x);
      if (token.length < minlength) {
        return null;
      }
      if (this.isInteger(token)) {
        return token;
      }
    }
  return null;
  };
  val=val+"";
  format=format+"";
  var i_val=0;
  var i_format=0;
  var c="";
  var token="";
  var token2="";
  var x,y;
  var year=new Date().getFullYear();
  var month=1;
  var date=1;
  var hh=0;
  var mm=0;
  var ss=0;
  var ampm="";
  while (i_format < format.length) {
    // Get next token from format string
    c=format.charAt(i_format);
    token="";
    while ((format.charAt(i_format)==c) && (i_format < format.length)) {
      token += format.charAt(i_format++);
    }
    // Extract contents of value based on format token
    //FARR.debug(token);
    if (token=="yyyy" || token=="yy" || token=="y") {
      if (token=="yyyy") {
        x=4;y=4;
      }
      if (token=="yy") {
        x=2;y=2;
      }
      if (token=="y") {
        x=2;y=4;
      }
      year=this.getInt(val,i_val,x,y);
      if (year==null) {
        return null;
      }
      i_val += year.length;
      if (year.length==2) {
        if (year > 70) {
          year=1900+(year-0);
        }
        else {
          year=2000+(year-0);
        }
      }
    }
    else if (token=="MMM" || token=="NNN"){
      month=0;
      var names = (token=="MMM"?(Date.monthNames.concat(Date.monthAbbreviations)):Date.monthAbbreviations);
      for (var i=0; i<names.length; i++) {
        var month_name=names[i];
        if (val.substring(i_val,i_val+month_name.length).toLowerCase()==month_name.toLowerCase()) {
          month=(i%12)+1;
          i_val += month_name.length;
          break;
        }
      }
      if ((month < 1)||(month>12)){
        return null;
      }
    }
    else if (token=="EE"||token=="E"){
      //FARR.debug("Got to token==EE");
      var names = (token=="EE"?Date.dayNames:Date.dayAbbreviations);
      for (var i=0; i<names.length; i++) {
        var day_name=names[i];
        if (val.substring(i_val,i_val+day_name.length).toLowerCase()==day_name.toLowerCase()) {
          i_val += day_name.length;
          break;
        }
      }
    }
    else if (token=="MM"||token=="M") {
      month=this.getInt(val,i_val,token.length,2);
      if(month==null||(month<1)||(month>12)){
        return null;
      }
      i_val+=month.length;
    }
    else if (token=="dd"||token=="d") {
      date=this.getInt(val,i_val,token.length,2);
      if(date==null||(date<1)||(date>31)){
        return null;
      }
      i_val+=date.length;
    }
    else if (token=="hh"||token=="h") {
      hh=this.getInt(val,i_val,token.length,2);
      if(hh==null||(hh<1)||(hh>12)){
        return null;
      }
      i_val+=hh.length;
    }
    else if (token=="HH"||token=="H") {
      hh=this.getInt(val,i_val,token.length,2);
      if(hh==null||(hh<0)||(hh>23)){
        return null;
      }
      i_val+=hh.length;
    }
    else if (token=="KK"||token=="K") {
      hh=this.getInt(val,i_val,token.length,2);
      if(hh==null||(hh<0)||(hh>11)){
        return null;
      }
      i_val+=hh.length;
      hh++;
    }
    else if (token=="kk"||token=="k") {
      hh=this.getInt(val,i_val,token.length,2);
      if(hh==null||(hh<1)||(hh>24)){
        return null;
      }
      i_val+=hh.length;
      hh--;
    }
    else if (token=="mm"||token=="m") {
      mm=this.getInt(val,i_val,token.length,2);
      if(mm==null||(mm<0)||(mm>59)){
        return null;
      }
      i_val+=mm.length;
    }
    else if (token=="ss"||token=="s") {
      ss=this.getInt(val,i_val,token.length,2);
      if(ss==null||(ss<0)||(ss>59)){
        return null;
      }
      i_val+=ss.length;
    }
    else if (token=="a") {
      if (val.substring(i_val,i_val+2).toLowerCase()=="am") {
        ampm="AM";
      }
      else if (val.substring(i_val,i_val+2).toLowerCase()=="pm") {
        ampm="PM";
      }
      else {
        return null;
      }
      i_val+=2;
    }
    else {
      //FARR.debug(token);
      if (val.substring(i_val,i_val+token.length)!=token) {
        return null;
      }
      else {
        i_val+=token.length;
      }
    }
  }
  // If there are any trailing characters left in the value, it doesn't match
  if (i_val != val.length) {
    return null;
  }
  // Is date valid for month?
  if (month==2) {
    // Check for leap year
    if ( ( (year%4==0)&&(year%100 != 0) ) || (year%400==0) ) { // leap year
      if (date > 29){
        return null;
      }
    }
    else {
      if (date > 28) {
        return null;
      }
    }
  }
  if ((month==4)||(month==6)||(month==9)||(month==11)) {
    if (date > 30) {
      return null;
    }
  }
  // Correct hours value
  if (hh<12 && ampm=="PM") {
    hh=hh-0+12;
  }
  else if (hh>11 && ampm=="AM") {
    hh-=12;
  }
  return new Date(year,month-1,date,hh,mm,ss);
};

// Check if a date string is valid
Date.isValid = function(val,format) {
  return (Date.parseString(val,format) != null);
};

// Check if a date object is before another date object
Date.prototype.isBefore = function(date2) {
  if (date2==null) {
    return false;
  }
  return (this.getTime()<date2.getTime());
};

// Check if a date object is after another date object
Date.prototype.isAfter = function(date2) {
  if (date2==null) {
    return false;
  }
  return (this.getTime()>date2.getTime());
};

// Check if two date objects have equal dates and times
Date.prototype.equals = function(date2) {
  if (date2==null) {
    return false;
  }
  return (this.getTime()==date2.getTime());
};

// Check if two date objects have equal dates, disregarding times
Date.prototype.equalsIgnoreTime = function(date2) {
  if (date2==null) {
    return false;
  }
  var d1 = new Date(this.getTime()).clearTime();
  var d2 = new Date(date2.getTime()).clearTime();
  return (d1.getTime()==d2.getTime());
};

// Format a date into a string using a given format string
Date.prototype.format = function(format) {
  format=format+"";
  var result="";
  var i_format=0;
  var c="";
  var token="";
  var y=this.getYear()+"";
  var M=this.getMonth()+1;
  var d=this.getDate();
  var E=this.getDay();
  var H=this.getHours();
  var m=this.getMinutes();
  var s=this.getSeconds();
  var yyyy,yy,MMM,MM,dd,hh,h,mm,ss,ampm,HH,H,KK,K,kk,k;
  // Convert real date parts into formatted versions
  var value=new Object();
  if (y.length < 4) {
    y=""+(+y+1900);
  }
  value["y"]=""+y;
  value["yyyy"]=y;
  value["yy"]=y.substring(2,4);
  value["M"]=M;
  value["MM"]=Date.LZ(M);
  value["MMM"]=Date.monthNames[M-1];
  value["NNN"]=Date.monthAbbreviations[M-1];
  value["d"]=d;
  value["dd"]=Date.LZ(d);
  value["E"]=Date.dayAbbreviations[E];
  value["EE"]=Date.dayNames[E];
  //FARR.debug(E);
  //FARR.debug(Date.dayNames[E]);
  value["H"]=H;
  value["HH"]=Date.LZ(H);
  if (H==0){
    value["h"]=12;
  }
  else if (H>12){
    value["h"]=H-12;
  }
  else {
    value["h"]=H;
  }
  value["hh"]=Date.LZ(value["h"]);
  value["K"]=value["h"]-1;
  value["k"]=value["H"]+1;
  value["KK"]=Date.LZ(value["K"]);
  value["kk"]=Date.LZ(value["k"]);
  if (H > 11) {
    value["a"]="PM";
  }
  else {
    value["a"]="AM";
  }
  value["m"]=m;
  value["mm"]=Date.LZ(m);
  value["s"]=s;
  value["ss"]=Date.LZ(s);
  while (i_format < format.length) {
    c=format.charAt(i_format);
    token="";
    while ((format.charAt(i_format)==c) && (i_format < format.length)) {
      token += format.charAt(i_format++);
    }
    if (typeof(value[token])!="undefined") {
      result=result + value[token];
    }
    else {
      result=result + token;
    }
  }
  return result;
};

// Get the full name of the day for a date
Date.prototype.getDayName = function() {
  return Date.dayNames[this.getDay()];
};

// Get the abbreviation of the day for a date
Date.prototype.getDayAbbreviation = function() {
  return Date.dayAbbreviations[this.getDay()];
};

// Get the full name of the month for a date
Date.prototype.getMonthName = function() {
  return Date.monthNames[this.getMonth()];
};

// Get the abbreviation of the month for a date
Date.prototype.getMonthAbbreviation = function() {
  return Date.monthAbbreviations[this.getMonth()];
};

// Clear all time information in a date object
Date.prototype.clearTime = function() {
  this.setHours(0);
  this.setMinutes(0);
  this.setSeconds(0);
  this.setMilliseconds(0);
  return this;
};

// Add an amount of time to a date. Negative numbers can be passed to subtract time.
Date.prototype.add = function(interval, number) {
  if (typeof(interval)=="undefined" || interval==null || typeof(number)=="undefined" || number==null) {
    return this;
  }
  number = +number;
  if (interval=='y') { // year
    this.setFullYear(this.getFullYear()+number);
  }
  else if (interval=='M') { // Month
    this.setMonth(this.getMonth()+number);
  }
  else if (interval=='d') { // Day
    this.setDate(this.getDate()+number);
  }
  else if (interval=='w') { // Weekday
    var step = (number>0)?1:-1;
    while (number!=0) {
      this.add('d',step);
      while(this.getDay()==0 || this.getDay()==6) {
        this.add('d',step);
      }
      number -= step;
    }
  }
  else if (interval=='h') { // Hour
    this.setHours(this.getHours() + number);
  }
  else if (interval=='m') { // Minute
    this.setMinutes(this.getMinutes() + number);
  }
  else if (interval=='s') { // Second
    this.setSeconds(this.getSeconds() + number);
  }
  return this;
};

//+ Jonas Raoni Soares Silva
//@ http://jsfromhell.com/geral/utf-8 [rev. #1]

UTF8 = {
    encode: function(s){
        for(var c, i = -1, l = (s = s.split("")).length, o = String.fromCharCode; ++i < l;
            s[i] = (c = s[i].charCodeAt(0)) >= 127 ? o(0xc0 | (c >>> 6)) + o(0x80 | (c & 0x3f)) : s[i]
        );
        return s.join("");
    },
    decode: function(s){
        for(var a, b, i = -1, l = (s = s.split("")).length, o = String.fromCharCode, c = "charCodeAt"; ++i < l;
            ((a = s[i][c](0)) & 0x80) &&
            (s[i] = (a & 0xfc) == 0xc0 && ((b = s[i + 1][c](0)) & 0xc0) == 0x80 ?
            o(((a & 0x03) << 6) + (b & 0x3f)) : o(128), s[++i] = "")
        );
        return s.join("");
    }
};
